/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_configure (void)
{
  GtkWidget *configure;
  GtkWidget *vbox1;
  GtkWidget *notebook1;
  GtkWidget *vbox2;
  GtkWidget *hbox3;
  GtkWidget *frame1;
  GtkWidget *sampling_rate;
  GList *sampling_rate_items = NULL;
  GtkWidget *sampling_rate_entry;
  GtkWidget *frame2;
  GtkWidget *hbox4;
  GSList *hbox4_group = NULL;
  GtkWidget *resolution_16;
  GtkWidget *resolution_8;
  GtkWidget *frame3;
  GtkWidget *hbox5;
  GSList *hbox5_group = NULL;
  GtkWidget *channels_2;
  GtkWidget *channels_1;
  GtkWidget *hbox6;
  GtkWidget *frame5;
  GtkWidget *vbox3;
  GtkWidget *interpolation;
  GtkWidget *echo;
  GtkWidget *label1;
  GtkWidget *hbuttonbox1;
  GtkWidget *cf_ok;
  GtkWidget *cf_cancel;
  GtkWidget *cf_apply;

  configure = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (configure), "configure", configure);
  gtk_container_set_border_width (GTK_CONTAINER (configure), 4);
  gtk_window_set_title (GTK_WINDOW (configure), "SPC Input Plugin for XMMS - Configure");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (configure), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (configure), vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (configure), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (vbox1), notebook1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (notebook1), 4);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (configure), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox2);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (configure), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, FALSE, 0);

  frame1 = gtk_frame_new ("Sampling Rate");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (configure), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox3), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 4);

  sampling_rate = gtk_combo_new ();
  gtk_widget_ref (sampling_rate);
  gtk_object_set_data_full (GTK_OBJECT (configure), "sampling_rate", sampling_rate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sampling_rate);
  gtk_container_add (GTK_CONTAINER (frame1), sampling_rate);
  gtk_container_set_border_width (GTK_CONTAINER (sampling_rate), 4);
  sampling_rate_items = g_list_append (sampling_rate_items, "48000");
  sampling_rate_items = g_list_append (sampling_rate_items, "44100");
  sampling_rate_items = g_list_append (sampling_rate_items, "32000");
  sampling_rate_items = g_list_append (sampling_rate_items, "24000");
  sampling_rate_items = g_list_append (sampling_rate_items, "23900");
  sampling_rate_items = g_list_append (sampling_rate_items, "16000");
  sampling_rate_items = g_list_append (sampling_rate_items, "8000");
  sampling_rate_items = g_list_append (sampling_rate_items, "4000");
  gtk_combo_set_popdown_strings (GTK_COMBO (sampling_rate), sampling_rate_items);
  g_list_free (sampling_rate_items);

  sampling_rate_entry = GTK_COMBO (sampling_rate)->entry;
  gtk_widget_ref (sampling_rate_entry);
  gtk_object_set_data_full (GTK_OBJECT (configure), "sampling_rate_entry", sampling_rate_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sampling_rate_entry);
  gtk_entry_set_text (GTK_ENTRY (sampling_rate_entry), "44100");

  frame2 = gtk_frame_new ("Resolution");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (configure), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (hbox3), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 4);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (configure), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (frame2), hbox4);

  resolution_16 = gtk_radio_button_new_with_label (hbox4_group, "16 bit");
  hbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (resolution_16));
  gtk_widget_ref (resolution_16);
  gtk_object_set_data_full (GTK_OBJECT (configure), "resolution_16", resolution_16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_16);
  gtk_box_pack_start (GTK_BOX (hbox4), resolution_16, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (resolution_16), 4);

  resolution_8 = gtk_radio_button_new_with_label (hbox4_group, "8 bit");
  hbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (resolution_8));
  gtk_widget_ref (resolution_8);
  gtk_object_set_data_full (GTK_OBJECT (configure), "resolution_8", resolution_8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_8);
  gtk_box_pack_start (GTK_BOX (hbox4), resolution_8, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (resolution_8), 4);

  frame3 = gtk_frame_new ("Channels");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (configure), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox3), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 4);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (configure), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (frame3), hbox5);

  channels_2 = gtk_radio_button_new_with_label (hbox5_group, "Stereo");
  hbox5_group = gtk_radio_button_group (GTK_RADIO_BUTTON (channels_2));
  gtk_widget_ref (channels_2);
  gtk_object_set_data_full (GTK_OBJECT (configure), "channels_2", channels_2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (channels_2);
  gtk_box_pack_start (GTK_BOX (hbox5), channels_2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (channels_2), 4);

  channels_1 = gtk_radio_button_new_with_label (hbox5_group, "Mono");
  hbox5_group = gtk_radio_button_group (GTK_RADIO_BUTTON (channels_1));
  gtk_widget_ref (channels_1);
  gtk_object_set_data_full (GTK_OBJECT (configure), "channels_1", channels_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (channels_1);
  gtk_box_pack_start (GTK_BOX (hbox5), channels_1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (channels_1), 4);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (configure), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox6, TRUE, TRUE, 0);

  frame5 = gtk_frame_new ("Effects");
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (configure), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (hbox6), frame5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 4);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (configure), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (frame5), vbox3);

  interpolation = gtk_check_button_new_with_label ("Interpolation");
  gtk_widget_ref (interpolation);
  gtk_object_set_data_full (GTK_OBJECT (configure), "interpolation", interpolation,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (interpolation);
  gtk_box_pack_start (GTK_BOX (vbox3), interpolation, FALSE, FALSE, 0);

  echo = gtk_check_button_new_with_label ("Echo");
  gtk_widget_ref (echo);
  gtk_object_set_data_full (GTK_OBJECT (configure), "echo", echo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (echo);
  gtk_box_pack_start (GTK_BOX (vbox3), echo, FALSE, FALSE, 0);

  label1 = gtk_label_new ("Quality");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (configure), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label1);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (configure), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (hbuttonbox1, GTK_CAN_DEFAULT);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox1), 0);

  cf_ok = gtk_button_new_with_label ("OK");
  gtk_widget_ref (cf_ok);
  gtk_object_set_data_full (GTK_OBJECT (configure), "cf_ok", cf_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cf_ok);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), cf_ok);
  GTK_WIDGET_SET_FLAGS (cf_ok, GTK_CAN_DEFAULT);

  cf_cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cf_cancel);
  gtk_object_set_data_full (GTK_OBJECT (configure), "cf_cancel", cf_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cf_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), cf_cancel);
  GTK_WIDGET_SET_FLAGS (cf_cancel, GTK_CAN_DEFAULT);

  cf_apply = gtk_button_new_with_label ("Apply");
  gtk_widget_ref (cf_apply);
  gtk_object_set_data_full (GTK_OBJECT (configure), "cf_apply", cf_apply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cf_apply);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), cf_apply);
  GTK_WIDGET_SET_FLAGS (cf_apply, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (cf_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_cf_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cf_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_cf_cancel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cf_apply), "clicked",
                      GTK_SIGNAL_FUNC (on_cf_apply_clicked),
                      NULL);

  gtk_widget_grab_default (cf_ok);
  return configure;
}

GtkWidget*
create_tag (void)
{
  GtkWidget *tag;
  GtkWidget *vbox4;
  GtkWidget *frame6;
  GtkWidget *table1;
  GtkWidget *label2;
  GtkWidget *label4;
  GtkWidget *label3;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label10;
  GtkWidget *label11;
  GtkWidget *hbox7;
  GtkWidget *tag_date_yyyy;
  GtkWidget *label12;
  GtkWidget *tag_date_mm;
  GtkWidget *label13;
  GtkWidget *tag_date_dd;
  GtkWidget *tag_playtime;
  GtkWidget *tag_fadetime;
  GtkWidget *tag_comments;
  GtkWidget *label14;
  GtkWidget *tag_emulator;
  GtkWidget *tag_emulator_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *tag_author;
  GtkWidget *tag_dumpername;
  GtkWidget *tag_gametitle;
  GtkWidget *tag_songname;
  GtkWidget *hbuttonbox2;
  GtkWidget *tag_save;
  GtkWidget *tag_remove;
  GtkWidget *tag_cancel;

  tag = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (tag), "tag", tag);
  gtk_window_set_title (GTK_WINDOW (tag), "window1");

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (tag), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (tag), vbox4);

  frame6 = gtk_frame_new ("ID666 Tag");
  gtk_widget_ref (frame6);
  gtk_object_set_data_full (GTK_OBJECT (tag), "frame6", frame6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame6);
  gtk_box_pack_start (GTK_BOX (vbox4), frame6, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame6), 4);

  table1 = gtk_table_new (10, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (tag), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame6), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 4);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 4);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 4);

  label2 = gtk_label_new ("Song name");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label4 = gtk_label_new ("Dumper's name");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label3 = gtk_label_new ("Game title");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label5 = gtk_label_new ("Author");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label6 = gtk_label_new ("Comments");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table1), label6, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label7 = gtk_label_new ("Channel Disables");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_table_attach (GTK_TABLE (table1), label7, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label8 = gtk_label_new ("Emulator");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table1), label8, 0, 1, 6, 7,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label9 = gtk_label_new ("Dumpdate");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_table_attach (GTK_TABLE (table1), label9, 0, 1, 7, 8,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label10 = gtk_label_new ("Playtime");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_table_attach (GTK_TABLE (table1), label10, 0, 1, 8, 9,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label11 = gtk_label_new ("Fadetime");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_table_attach (GTK_TABLE (table1), label11, 0, 1, 9, 10,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (tag), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_table_attach (GTK_TABLE (table1), hbox7, 1, 2, 7, 8,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  tag_date_yyyy = gtk_entry_new_with_max_length (4);
  gtk_widget_ref (tag_date_yyyy);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_date_yyyy", tag_date_yyyy,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_date_yyyy);
  gtk_box_pack_start (GTK_BOX (hbox7), tag_date_yyyy, FALSE, FALSE, 4);
  gtk_widget_set_usize (tag_date_yyyy, 48, -2);

  label12 = gtk_label_new ("/");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (hbox7), label12, FALSE, FALSE, 4);

  tag_date_mm = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (tag_date_mm);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_date_mm", tag_date_mm,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_date_mm);
  gtk_box_pack_start (GTK_BOX (hbox7), tag_date_mm, FALSE, FALSE, 4);
  gtk_widget_set_usize (tag_date_mm, 32, -2);

  label13 = gtk_label_new ("/");
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_box_pack_start (GTK_BOX (hbox7), label13, FALSE, FALSE, 4);

  tag_date_dd = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (tag_date_dd);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_date_dd", tag_date_dd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_date_dd);
  gtk_box_pack_start (GTK_BOX (hbox7), tag_date_dd, FALSE, FALSE, 4);
  gtk_widget_set_usize (tag_date_dd, 32, -2);

  tag_playtime = gtk_entry_new_with_max_length (10);
  gtk_widget_ref (tag_playtime);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_playtime", tag_playtime,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_playtime);
  gtk_table_attach (GTK_TABLE (table1), tag_playtime, 1, 2, 8, 9,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  tag_fadetime = gtk_entry_new_with_max_length (10);
  gtk_widget_ref (tag_fadetime);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_fadetime", tag_fadetime,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_fadetime);
  gtk_table_attach (GTK_TABLE (table1), tag_fadetime, 1, 2, 9, 10,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  tag_comments = gtk_entry_new_with_max_length (32);
  gtk_widget_ref (tag_comments);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_comments", tag_comments,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_comments);
  gtk_table_attach (GTK_TABLE (table1), tag_comments, 1, 2, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  label14 = gtk_label_new ("N/A");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (tag), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_table_attach (GTK_TABLE (table1), label14, 1, 2, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  tag_emulator = gtk_option_menu_new ();
  gtk_widget_ref (tag_emulator);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_emulator", tag_emulator,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_emulator);
  gtk_table_attach (GTK_TABLE (table1), tag_emulator, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  tag_emulator_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("Unknown");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (tag_emulator_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("ZSnes");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (tag_emulator_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Snes9X");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (tag_emulator_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (tag_emulator), tag_emulator_menu);

  tag_author = gtk_entry_new_with_max_length (32);
  gtk_widget_ref (tag_author);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_author", tag_author,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_author);
  gtk_table_attach (GTK_TABLE (table1), tag_author, 1, 2, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  tag_dumpername = gtk_entry_new_with_max_length (16);
  gtk_widget_ref (tag_dumpername);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_dumpername", tag_dumpername,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_dumpername);
  gtk_table_attach (GTK_TABLE (table1), tag_dumpername, 1, 2, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  tag_gametitle = gtk_entry_new_with_max_length (32);
  gtk_widget_ref (tag_gametitle);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_gametitle", tag_gametitle,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_gametitle);
  gtk_table_attach (GTK_TABLE (table1), tag_gametitle, 1, 2, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  tag_songname = gtk_entry_new_with_max_length (32);
  gtk_widget_ref (tag_songname);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_songname", tag_songname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_songname);
  gtk_table_attach (GTK_TABLE (table1), tag_songname, 1, 2, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 4, 0);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox2);
  gtk_object_set_data_full (GTK_OBJECT (tag), "hbuttonbox2", hbuttonbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (vbox4), hbuttonbox2, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox2), 4);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox2), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox2), 0);

  tag_save = gtk_button_new_with_label ("Save");
  gtk_widget_ref (tag_save);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_save", tag_save,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_save);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), tag_save);
  GTK_WIDGET_SET_FLAGS (tag_save, GTK_CAN_DEFAULT);

  tag_remove = gtk_button_new_with_label ("Remove");
  gtk_widget_ref (tag_remove);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_remove", tag_remove,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_remove);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), tag_remove);
  GTK_WIDGET_UNSET_FLAGS (tag_remove, GTK_CAN_FOCUS);
  GTK_WIDGET_SET_FLAGS (tag_remove, GTK_CAN_DEFAULT);

  tag_cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (tag_cancel);
  gtk_object_set_data_full (GTK_OBJECT (tag), "tag_cancel", tag_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), tag_cancel);
  GTK_WIDGET_SET_FLAGS (tag_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (tag_save), "clicked",
                      GTK_SIGNAL_FUNC (on_tag_save_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tag_remove), "clicked",
                      GTK_SIGNAL_FUNC (on_tag_remove_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tag_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_tag_cancel_clicked),
                      NULL);

  gtk_widget_grab_default (tag_save);
  return tag;
}

